#include <string.h>
#include <stdio.h>

#include "../../emu/h/types.h"
#include "../../emu/h/emuFileHandling.h"
#include "../../nes/h/nesGeneral.h"
#include "../../emu/h/emuGeneral.h"
#include "../../nes/h/ppu.h"
#include "main.h"

extern u8 rom_start[], rom_end[];

int postLoad()
{
	return 0;
}

int checkHeadInfo(int val)
{
	if (val & ~(0x20 | 0x40) != 0)
		return -1;
	else
		return 0;
}

int LoadHeader(u8 *header)		//copy the 16 byte header of the nes file into header
{
	long size;

/*	FILE *fileId;
	fileId = fopen(szFilename,"rb");
	if (fileId == 0)
		return 0;
	
	fseek(fileId, 0, SEEK_END);
*/
//	size = ftell(fileId);
	size = rom_end - rom_start;
	
/*	fseek(fileId, 0, SEEK_SET);
	fread(header, 1, 16, fileId);
	fclose(fileId);
	*/
	memcpy(header, rom_start, 16);
	return size;
}

void LoadWram()						//Dont need this
{
	/*
	FILE *f; unsigned int i;
	char szPath[260];

	GetLocalPath("save\\", "sav", szPath, sizeof(szPath));

	f = fopen(szPath, "rb");
	if (f == 0)
		return;

	fseek(f, 0, SEEK_SET);
	if ((i = fread(wram, 1, sramSize, f)) != sramSize)
		emuMsg("Error in load sram");

	fclose(f);
	*/
}

void SaveWram()						//Dont need this
{
	/*
	FILE *f;
	char szPath[260];

	if (!header.sram)
		return;

	GetLocalPath("save\\", "sav", szPath, sizeof(szPath));

	f = fopen(szPath, "wb");
	if (f == 0)
	{
		emuMsg( "Could not save SRAM" );
		return;
	}
	fseek(f, 0, SEEK_SET);				//Set file to the beginning
	if (fwrite(wram, 1, sramSize, f) != sramSize)
		emuMsg("Error in save sram");
	fclose(f);							//done, close it
	*/
}

int loadImage(int size)
{
	int i;
	
	i = SetPrgChrMemory();
	if (i)
		return 0;
	
	imageSize = size;

	//make prgromPtr point to the prgrom data.  size is header.prg * 0x400 * 16
	//make chrromPtr point to the chrrom data.  size is header.chr * 0x400 * 8
	//its <16byte header> <512 trainer> <prgrom> <chrrom>
/*														
	FILE *fileId;

	fileId = fopen(szFilename, "rb");
	if (!fileId)
	{
		emuMsg("Error loading file");
		return 0;
	}

	fseek(fileId, header.trainer ? 512 + 16: 16, SEEK_SET);
	fread(prgromPtr, 1, header.prg * 0x400 * 16, fileId);
	fread(chrromPtr, 1, header.chr * 0x400 * 8,  fileId);
*/
	{
		int offset;
		offset = header.trainer ? 512 + 16: 16;
		memcpy(prgromPtr, rom_start + offset, header.prg * 0x400 * 16);
		memcpy(chrromPtr, rom_start + offset+ header.prg * 0x400 * 16, header.chr * 0x400 * 8);
	}
	/*
	if (header.footer)
	{
		int iEnd, iEOF;
		fseek(fileId, 0, SEEK_END);
		iEOF = ftell(fileId);
		iEnd = size + ( header.trainer ? 512+16 : 16 );
		header.footerText = new char [iEOF-iEnd+1];
		fseek(fileId, iEnd, SEEK_SET);
		fread(header.footerText, 1, iEOF-iEnd, fileId);
		header.footerText[iEOF-iEnd] = 0;
	}
	fclose(fileId);	
*/
//StickThefilename here if there is one. It will change it to NTSC/PAL is a (j) or u or e is in it
	//setRegionMode(szFilename);
	
	return size;
}
