#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <stdio.h>
#include <gccore.h>
#include <ogcsys.h>
#include "main.h"
#include "../../nes/h/nesGeneral.h"
#include "../../emu/h/emuPalette.h"

#define DEFAULT_FIFO_SIZE			GX_FIFO_MINSIZE

//Fix w/e you need to
u32 first_frame = 1;
/*
// Buffer to keep data read/written from/to memcard
static u8 testcardbuffer[8192] ATTRIBUTE_ALIGN(32);

// Is the card mounted?
static vu32 mounted = 0;

// Memory for memcard file-entries etc
static u8 sysarea[CARD_WORKAREA] ATTRIBUTE_ALIGN(32);
*/
/*
This function is called if the card is physically removed
from your gamecube, the remove-interrupt. There is no
insert-interrupt, unfortunatly.
*/
/*
void card_removed(s32 chn,s32 result)
{
	printf("card was removed. Put it back in!\n");
	CARD_Unmount(chn);
	mounted = 0;
}

card_file card;
*/

GXRModeObj *rmode;
void *xfb;
GXColor background = {0, 0, 0, 0xff};

void draw_init();
void draw_square(Mtx v);
static void copy_to_xfb(u32 count);
static u32 do_copy = GX_FALSE;
static float rotby=0;
Mtx v,p; // view and perspective matrices
u32 NES_Screen[256*240]; // NES Framebuffer

static GXTexObj texture;

struct camera
{
	Vector pos;
	Vector up;
	Vector view;
};

struct SSurface {
	unsigned char *Surface;
	unsigned int Pitch;
	unsigned int Width, Height;
};

typedef struct _RECT { 
  long left; 
  long top; 
  long right; 
  long bottom; 
} RECT, *PRECT;

s16 square[] ATTRIBUTE_ALIGN(32) =
{
	// x y z
	-30,  30,  0, 	// 0
	 30,  30,  0, 	// 1
	 30, -30,  0, 	// 2
	-30, -30,  0, 	// 3
};

u8 colors[] ATTRIBUTE_ALIGN(32) =
{
	// r, g, b, a
	0,  255, 0, 0, // 0 purple
	240,   0,   0, 255,	// 1 red
	255, 180,   0, 255,	// 2 orange
	255, 255,   0, 255, // 3 yellow
	 10, 120,  40, 255, // 4 green
	  0,  20, 100, 255  // 5 blue
};

camera cam = {{0.0F, 0.0F, 0.0F},
	{0.0F, 1.0F, 0.0F},
	{0.0F, 0.0F, -1.0F}};

//Junk code, do somthing!
//You should init everything here, then call your menu. After you have selected a game
//You call loadImage, you must program a way for loadImage to know the file you want
//then its function to load the file.
//then do brunNes = 1; runTheNes();

void runTheNes()
{
runNesAgain:
	if (!brunNes)
		return;

	runNes();
	if (nesMode & resetLoop)
	{
		nesMode ^= resetLoop;
		brunNes = 1;
		goto runNesAgain;
	}
	//SDL_WM_SetCaption(wndName, 0);
}

int main()
{
	
	AUDIO_Init(NULL);
	VIDEO_Init();

	consoleFps = 60;		//!
	switch(VIDEO_GetCurrentTvMode())
	{
		case VI_NTSC:
			rmode = &TVNtsc480IntDf;
			break;
		case VI_PAL:
			rmode = &TVPal528IntDf;
			break;
		case VI_MPAL:
			rmode = &TVMpal480IntDf;
			break;
		default:
			rmode = &TVNtsc480IntDf;
			break;
	}

	PAD_Init();

	xfb = MEM_K0_TO_K1(memalign(VIDEO_PadFramebufferWidth(rmode->fbWidth)*rmode->xfbHeight*VI_DISPLAY_PIX_SZ,32));
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode & VI_NON_INTERLACE) VIDEO_WaitVSync();
	
	void *gp_fifo = NULL;
	gp_fifo = MEM_K0_TO_K1(memalign(DEFAULT_FIFO_SIZE,32));
	memset(gp_fifo,0,DEFAULT_FIFO_SIZE);

	GX_Init(gp_fifo,DEFAULT_FIFO_SIZE);

	GX_SetCopyClear(background, 0x00ffffff);

	GX_SetViewport(0,0,rmode->fbWidth,rmode->efbHeight,0,1); 
	GX_SetDispCopyYScale((f32)rmode->xfbHeight/(f32)rmode->efbHeight);
	GX_SetScissor(0,0,rmode->fbWidth,rmode->efbHeight);
	GX_SetDispCopySrc(0,0,rmode->fbWidth,rmode->efbHeight); 
	GX_SetDispCopyDst(rmode->fbWidth,rmode->xfbHeight);
	GX_SetCopyFilter(rmode->aa,rmode->sample_pattern,GX_TRUE,rmode->vfilter);
	GX_SetFieldMode(rmode->field_rendering,((rmode->viHeight==2*rmode->xfbHeight)?GX_ENABLE:GX_DISABLE));

	if (rmode->aa) GX_SetPixelFmt(GX_PF_RGB565_Z16, GX_ZC_LINEAR);
	else GX_SetPixelFmt(GX_PF_RGB8_Z24, GX_ZC_LINEAR);

	GX_SetCullMode(GX_CULL_NONE);
	GX_CopyDisp(xfb,GX_TRUE);
	GX_SetDispCopyGamma(GX_GM_1_0);

	guPerspective(p, 60, 1.33F, 10.0F, 1000.0F);
	GX_LoadProjectionMtx(p, GX_PERSPECTIVE);
	
	initPalette32();
	
	draw_init();
	
	while(1)
	{
		// Emulation loop goes here
		
	}
	free(xfb);

}


void draw_init()
{
	GX_ClearVtxDesc();
	GX_SetVtxDesc(GX_VA_POS, GX_INDEX8);
	GX_SetVtxDesc(GX_VA_CLR0, GX_INDEX8);
	GX_SetVtxDesc(GX_VA_TEX0, GX_DIRECT);

	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS, GX_POS_XYZ, GX_S16, 0);
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
	GX_SetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

	GX_SetArray(GX_VA_POS, square, 3*sizeof(s16));
	GX_SetArray(GX_VA_CLR0, colors, 4*sizeof(u8));

	GX_SetNumTexGens(1);
	GX_SetTexCoordGen(GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY);

	GX_InvalidateTexAll();
	//!1 WTF screen.pixels?!?! stick in your texture

	/*!      screen.pixels is where GXTexObj *texture     */
	/*!        gets the texture data from, retard!        */
	/*! In case you didn't notice, that's GX_*INIT*TexObj */
 
	GX_InitTexObj(&texture, NES_Screen, 256, 240, GX_TF_RGBA8, GX_MIRROR, GX_MIRROR, GX_LINEAR);
}

void draw_vert(u8 pos, u8 c, f32 s, f32 t)
{
	GX_Position1x8(pos);
	GX_Color1x8(c);
	GX_TexCoord2f32(s, t);
}

void draw_square(Mtx v)
{
	Mtx m; // model matrix.
	Mtx mv; // modelview matrix.
	Vector axis = {0,0,1};

	guMtxIdentity(m);
	guMtxRotAxisDeg(m, &axis, rotby);
	guMtxTransApply(m, m, 0, 0, -100);

	guMtxConcat(v,m,mv);
	GX_LoadPosMtxImm(mv, GX_PNMTX0);


	GX_Begin(GX_QUADS, GX_VTXFMT0, 4);
		draw_vert(0, 0, 0.0, 0.0);
		draw_vert(1, 0, 1.0, 0.0);
		draw_vert(2, 0, 1.0, 1.0);
		draw_vert(3, 0, 0.0, 1.0);
	GX_End();
}

static void copy_to_xfb(u32 count)
{
	if(do_copy==GX_TRUE) {
		GX_SetZMode(GX_TRUE, GX_LEQUAL, GX_TRUE);
		GX_SetColorUpdate(GX_TRUE);
		GX_CopyDisp(xfb,GX_TRUE);
		GX_Flush();
		do_copy = GX_FALSE;
	}
}
