/*#include <stdlib.h>
//#include <math.h>
*/
//#include <stdio.h>
#include <malloc.h>
//#include <ogcsys.h>
#include <string.h>
#include <ogc/gx.h>
#include <gccore.h>

#include "../../emu/h/types.h"
#include "../../emu/h/emuPalette.h"
#include "../../nes/h/ppu.h"
#include "../../nes/h/nesGeneral.h"

#include "main.h"

long screenBuffer[256*240];

// #define DEFAULT_FIFO_SIZE			GX_FIFO_MINSIZE

char consoleFps;
char waitFor_VSynch;
char frameNumber;

u32 *screen;

/*
GXRModeObj *rmode;
GXColor background = {0, 0, 0, 0xff};

void GC_VideoSetup()
{	
	switch(VIDEO_GetCurrentTvMode()) {
		case VI_NTSC:
			rmode = &TVNtsc480IntDf;
			break;
		case VI_PAL:
			rmode = &TVPal528IntDf;
			break;
		case VI_MPAL:
			rmode = &TVMpal480IntDf;
			break;
		default:
			rmode = &TVNtsc480IntDf;
			break;
	}
	
	xfb = MEM_K0_TO_K1(memalign(VIDEO_PadFramebufferWidth(rmode->fbWidth)*rmode->xfbHeight*VI_DISPLAY_PIX_SZ,32));

	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetPostRetraceCallback(copy_to_xfb);
	VIDEO_SetBlack(FALSE);

	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();
	
	void *gp_fifo = NULL;
	gp_fifo = MEM_K0_TO_K1(memalign(DEFAULT_FIFO_SIZE,32));
	memset(gp_fifo,0,DEFAULT_FIFO_SIZE);

	GX_Init(gp_fifo,DEFAULT_FIFO_SIZE);

	GX_SetCopyClear(background, 0x00ffffff);

	GX_SetViewport(0,0,rmode->fbWidth,rmode->efbHeight,0,1); 
	GX_SetDispCopyYScale((f32)rmode->xfbHeight/(f32)rmode->efbHeight);
	GX_SetScissor(0,0,rmode->fbWidth,rmode->efbHeight);
	GX_SetDispCopySrc(0,0,rmode->fbWidth,rmode->efbHeight); 
	GX_SetDispCopyDst(rmode->fbWidth,rmode->xfbHeight);
	GX_SetCopyFilter(rmode->aa,rmode->sample_pattern,GX_TRUE,rmode->vfilter);
	GX_SetFieldMode(rmode->field_rendering,((rmode->viHeight==2*rmode->xfbHeight)?GX_ENABLE:GX_DISABLE));

	if (rmode->aa) GX_SetPixelFmt(GX_PF_RGB565_Z16, GX_ZC_LINEAR);
	else GX_SetPixelFmt(GX_PF_RGB8_Z24, GX_ZC_LINEAR);

	GX_SetCullMode(GX_CULL_NONE);
	GX_CopyDisp(xfb,GX_TRUE);
	GX_SetDispCopyGamma(GX_GM_1_0);

	guPerspective(p, 60, 1.33F, 10.0F, 1000.0F);
	GX_LoadProjectionMtx(p, GX_PERSPECTIVE);
	
	initPalette32();
	
	draw_init();
}
*/
//Define all the crap you need here. It is called once before the main loop starts
//Note: this can be called more then once. Like if you stop the nes
//with (brunNes=1 or nesMode |= resetLoop) This will be called before StartFrame & stuff
void FrameDef()
{
	waitFor_VSynch = 1;
	frameNumber = 0;
}

//This is called when you being the frame. 
void StartFrame(ui *pitch, void **surface)
						//pitch is the amount of *bytes* the width is
						//surface is the ptr to ram, must be 240 * pitch (256) * depth
{
	*surface = screenBuffer;
	*pitch = 256;
	
	VIDEO_SetNextFramebuffer(xfb);
	/*
	HUH?!
	if(first_frame)
	{
		first_frame = 0;
		VIDEO_SetBlack(FALSE);
	}
	*/

	/*
	if (pal16)
	{
		*surface = screen->pixels;
		*pitch = screen->pitch / 2;
	}
	
		works but.. why use it
	else if (pal24)
	{
		*surface = (void*)ddsdBack.lpSurface;
		*pitch = ddsdBack.lPitch;
	}
	else if (pal32)
	{
		*surface = screen->pixels;
		*pitch = screen->pitch / 4;
	}
	*/
}

//note: the NES is going into vblank now.

//called before endframe
void Render()
{
}

void GC_Render()
{
	// You move it into the texture and draw the poly to screen.
//!!! fix these :s
/*
	VIDEO_Flush();
	guLookAt(v, &cam.pos, &cam.up, &cam.view);

	GX_SetViewport(0,0,rmode->fbWidth,rmode->efbHeight,0,1);
	GX_InvVtxCache();
	GX_InvalidateTexAll();
	GX_SetTevOp(GX_TEVSTAGE0, GX_DECAL);
	GX_SetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);

	GX_SetNumChans(1);
	GX_LoadTexObj(&texture,GX_TEXMAP0);
	draw_square(v);
	GX_DrawDone();
	do_copy = GX_TRUE;
*/
}


void EndFrameNTSC()
{
	if (consoleFps == 50)
	{
		if (++frameNumber == 6)				//Skip refresh to catch up a frame
			waitFor_VSynch = 0;
	}
	else	//60
	{
	}
}

void EndFramePAL()
{
	if (consoleFps == 60)
	{
		if (++frameNumber == 6)				//2 RefreshGUI so it will die a frame & be in sync
			waitFor_VSynch = 2;
	}
	else	//50
	{
	}
}

// Finish the screen, do whatever you need
//this is the last function until the loop starts again
void RefreshGUI()
{
	if (waitFor_VSynch == 2)
	{
		frameNumber = 0;
		waitFor_VSynch = 1;
		RefreshGUI();					//2 RefreshGUI this time
	}
	else if (waitFor_VSynch == 0)		//Pal runing NTSC, kill refresh in order to run
	{									//the extra frames
		frameNumber = 0;
		waitFor_VSynch = 1;
		return;
	}
	
	VIDEO_WaitVSync();					//!!! render is after vsync right?
	GC_Render();
}
